Index: pjproject/branches/users/nanang/pjsip/src/pjsua-lib/pjsua_media.c
===================================================================
--- pjproject/branches/users/nanang/pjsip/src/pjsua-lib/pjsua_media.c	(revision 1697)
+++ pjproject/branches/users/nanang/pjsip/src/pjsua-lib/pjsua_media.c	(revision 1698)
@@ -535,7 +535,20 @@
 	    goto on_error;
 	}
-	status = pjmedia_transport_udp_attach(pjsua_var.med_endpt, NULL,
-					      &skinfo, 0,
-					      &pjsua_var.calls[i].med_tp);
+
+	if (pjsua_var.media_cfg.enable_srtp) {
+	    pjmedia_transport *tp;
+	    unsigned srtp_options = 
+				PJMEDIA_SRTP_AUTO_CLOSE_UNDERLYING_TRANSPORT;
+
+	    status = pjmedia_transport_udp_attach(pjsua_var.med_endpt, NULL,
+						  &skinfo, 0, &tp);
+	    status = pjmedia_transport_srtp_create(pjsua_var.med_endpt, tp,
+						   srtp_options, 
+						   &pjsua_var.calls[i].med_tp);
+	} else {
+	    status = pjmedia_transport_udp_attach(pjsua_var.med_endpt, NULL,
+						  &skinfo, 0,
+						  &pjsua_var.calls[i].med_tp);
+	}
 	if (status != PJ_SUCCESS) {
 	    pjsua_perror(THIS_FILE, "Unable to create media transport",
@@ -544,11 +557,11 @@
 	}
 
-	pjmedia_transport_udp_simulate_lost(pjsua_var.calls[i].med_tp,
-					    PJMEDIA_DIR_ENCODING,
-					    pjsua_var.media_cfg.tx_drop_pct);
-
-	pjmedia_transport_udp_simulate_lost(pjsua_var.calls[i].med_tp,
-					    PJMEDIA_DIR_DECODING,
-					    pjsua_var.media_cfg.rx_drop_pct);
+	pjmedia_transport_simulate_lost(pjsua_var.calls[i].med_tp,
+					PJMEDIA_DIR_ENCODING,
+					pjsua_var.media_cfg.tx_drop_pct);
+
+	pjmedia_transport_simulate_lost(pjsua_var.calls[i].med_tp,
+					PJMEDIA_DIR_DECODING,
+					pjsua_var.media_cfg.rx_drop_pct);
 
     }
@@ -646,11 +659,11 @@
 	}
 
-	pjmedia_ice_simulate_lost(pjsua_var.calls[i].med_tp,
-				  PJMEDIA_DIR_ENCODING,
-				  pjsua_var.media_cfg.tx_drop_pct);
-
-	pjmedia_ice_simulate_lost(pjsua_var.calls[i].med_tp,
-				  PJMEDIA_DIR_DECODING,
-				  pjsua_var.media_cfg.rx_drop_pct);
+	pjmedia_transport_simulate_lost(pjsua_var.calls[i].med_tp,
+				        PJMEDIA_DIR_ENCODING,
+				        pjsua_var.media_cfg.tx_drop_pct);
+
+	pjmedia_transport_simulate_lost(pjsua_var.calls[i].med_tp,
+				        PJMEDIA_DIR_DECODING,
+				        pjsua_var.media_cfg.rx_drop_pct);
 
 	status = pjmedia_ice_start_init(pjsua_var.calls[i].med_tp, 0, &addr,
@@ -757,5 +770,5 @@
 
 	/* Restart ICE */
-	pjmedia_ice_stop_ice(call->med_tp);
+	pjmedia_transport_media_stop(call->med_tp);
 
 	status = pjmedia_ice_init_ice(call->med_tp, ice_role, NULL, NULL);
@@ -769,4 +782,5 @@
 pj_status_t pjsua_media_channel_create_sdp(pjsua_call_id call_id, 
 					   pj_pool_t *pool,
+					   const pjmedia_sdp_session *rem_sdp,
 					   pjmedia_sdp_session **p_sdp)
 {
@@ -816,9 +830,11 @@
     }
 
-    if (pjsua_var.media_cfg.enable_ice) {
-	status = pjmedia_ice_modify_sdp(call->med_tp, pool, sdp);
+    //if (pjsua_var.media_cfg.enable_ice) {
+	//status = pjmedia_transport_media_create(call->med_tp, pool, sdp, NULL);
+	status = pjmedia_transport_media_create(call->med_tp, pool, 
+						sdp, rem_sdp);
 	if (status != PJ_SUCCESS)
 	    goto on_error;
-    }
+    //}
 
     *p_sdp = sdp;
@@ -859,7 +875,7 @@
     stop_media_session(call_id);
 
-    if (pjsua_var.media_cfg.enable_ice) {
-	pjmedia_ice_stop_ice(call->med_tp);
-    }
+    //if (pjsua_var.media_cfg.enable_ice) {
+	pjmedia_transport_media_stop(call->med_tp);
+    //}
 
     return PJ_SUCCESS;
@@ -885,5 +901,5 @@
 
 pj_status_t pjsua_media_channel_update(pjsua_call_id call_id,
-				       const pjmedia_sdp_session *local_sdp,
+				       pjmedia_sdp_session *local_sdp,
 				       const pjmedia_sdp_session *remote_sdp)
 {
@@ -947,7 +963,7 @@
 
 	/* Shutdown ICE session */
-	if (pjsua_var.media_cfg.enable_ice) {
-	    pjmedia_ice_stop_ice(call->med_tp);
-	}
+	//if (pjsua_var.media_cfg.enable_ice) {
+	    pjmedia_transport_media_stop(call->med_tp);
+	//}
 
 	/* No need because we need keepalive? */
@@ -955,10 +971,11 @@
     } else {
 	/* Start ICE */
-	if (pjsua_var.media_cfg.enable_ice) {
-	    status = pjmedia_ice_start_ice(call->med_tp, call->inv->pool, 
-					   remote_sdp, 0);
+	//if (pjsua_var.media_cfg.enable_ice) {
+	    status = pjmedia_transport_media_start(call->med_tp, 
+						   call->inv->pool,
+						   local_sdp, remote_sdp, 0);
 	    if (status != PJ_SUCCESS)
 		return status;
-	}
+	//}
 
 	/* Override ptime, if this option is specified. */
Index: pjproject/branches/users/nanang/third_party/build/srtp/config.h
===================================================================
--- pjproject/branches/users/nanang/third_party/build/srtp/config.h	(revision 1698)
+++ pjproject/branches/users/nanang/third_party/build/srtp/config.h	(revision 1698)
@@ -0,0 +1,3 @@
+#ifdef _WIN32
+#include "../../srtp/config.hw"
+#endif
Index: pjproject/branches/users/nanang/third_party/build/srtp/libsrtp.vcproj
===================================================================
--- pjproject/branches/users/nanang/third_party/build/srtp/libsrtp.vcproj	(revision 1698)
+++ pjproject/branches/users/nanang/third_party/build/srtp/libsrtp.vcproj	(revision 1698)
@@ -0,0 +1,431 @@
+<?xml version="1.0" encoding="Windows-1252"?>
+<VisualStudioProject
+	ProjectType="Visual C++"
+	Version="8.00"
+	Name="libsrtp"
+	ProjectGUID="{F0DBAA03-1BA3-4E3B-A2CA-727E3D3AB858}"
+	RootNamespace="libsrtp"
+	Keyword="Win32Proj"
+	>
+	<Platforms>
+		<Platform
+			Name="Win32"
+		/>
+	</Platforms>
+	<ToolFiles>
+	</ToolFiles>
+	<Configurations>
+		<Configuration
+			Name="Debug|Win32"
+			OutputDirectory=".\output\libsrtp-i386-win32-vc8-debug"
+			IntermediateDirectory=".\output\libsrtp-i386-win32-vc8-debug"
+			ConfigurationType="4"
+			CharacterSet="2"
+			>
+			<Tool
+				Name="VCPreBuildEventTool"
+			/>
+			<Tool
+				Name="VCCustomBuildTool"
+			/>
+			<Tool
+				Name="VCXMLDataGeneratorTool"
+			/>
+			<Tool
+				Name="VCWebServiceProxyGeneratorTool"
+			/>
+			<Tool
+				Name="VCMIDLTool"
+			/>
+			<Tool
+				Name="VCCLCompilerTool"
+				Optimization="0"
+				AdditionalIncludeDirectories=".,../../srtp/include,../../srtp/crypto/include"
+				PreprocessorDefinitions="WIN32;_DEBUG;_LIB"
+				MinimalRebuild="true"
+				BasicRuntimeChecks="3"
+				RuntimeLibrary="1"
+				UsePrecompiledHeader="0"
+				WarningLevel="3"
+				Detect64BitPortabilityProblems="true"
+				DebugInformationFormat="4"
+			/>
+			<Tool
+				Name="VCManagedResourceCompilerTool"
+			/>
+			<Tool
+				Name="VCResourceCompilerTool"
+			/>
+			<Tool
+				Name="VCPreLinkEventTool"
+			/>
+			<Tool
+				Name="VCLibrarianTool"
+				OutputFile="..\..\lib\libsrtp-i386-win32-vc8-debug.lib"
+			/>
+			<Tool
+				Name="VCALinkTool"
+			/>
+			<Tool
+				Name="VCXDCMakeTool"
+			/>
+			<Tool
+				Name="VCBscMakeTool"
+			/>
+			<Tool
+				Name="VCFxCopTool"
+			/>
+			<Tool
+				Name="VCPostBuildEventTool"
+			/>
+		</Configuration>
+		<Configuration
+			Name="Release|Win32"
+			OutputDirectory=".\output\libsrtp-i386-win32-vc8-release"
+			IntermediateDirectory=".\output\libsrtp-i386-win32-vc8-release"
+			ConfigurationType="4"
+			CharacterSet="2"
+			WholeProgramOptimization="1"
+			>
+			<Tool
+				Name="VCPreBuildEventTool"
+			/>
+			<Tool
+				Name="VCCustomBuildTool"
+			/>
+			<Tool
+				Name="VCXMLDataGeneratorTool"
+			/>
+			<Tool
+				Name="VCWebServiceProxyGeneratorTool"
+			/>
+			<Tool
+				Name="VCMIDLTool"
+			/>
+			<Tool
+				Name="VCCLCompilerTool"
+				AdditionalIncludeDirectories=".,../../srtp/include,../../srtp/crypto/include"
+				PreprocessorDefinitions="WIN32;NDEBUG;_LIB"
+				RuntimeLibrary="2"
+				UsePrecompiledHeader="0"
+				WarningLevel="3"
+				Detect64BitPortabilityProblems="true"
+				DebugInformationFormat="3"
+			/>
+			<Tool
+				Name="VCManagedResourceCompilerTool"
+			/>
+			<Tool
+				Name="VCResourceCompilerTool"
+			/>
+			<Tool
+				Name="VCPreLinkEventTool"
+			/>
+			<Tool
+				Name="VCLibrarianTool"
+				OutputFile="..\..\lib\libsrtp-i386-win32-vc8-release.lib"
+			/>
+			<Tool
+				Name="VCALinkTool"
+			/>
+			<Tool
+				Name="VCXDCMakeTool"
+			/>
+			<Tool
+				Name="VCBscMakeTool"
+			/>
+			<Tool
+				Name="VCFxCopTool"
+			/>
+			<Tool
+				Name="VCPostBuildEventTool"
+			/>
+		</Configuration>
+	</Configurations>
+	<References>
+	</References>
+	<Files>
+		<Filter
+			Name="Source Files"
+			Filter="cpp;c;cc;cxx;def;odl;idl;hpj;bat;asm;asmx"
+			UniqueIdentifier="{4FC737F1-C7A5-4376-A066-2A32D752A2FF}"
+			>
+			<File
+				RelativePath="..\..\srtp\srtp\srtp.c"
+				>
+			</File>
+		</Filter>
+		<Filter
+			Name="Header Files"
+			Filter="h;hpp;hxx;hm;inl;inc;xsd"
+			UniqueIdentifier="{93995380-89BD-4b04-88EB-625FBE52EBFB}"
+			>
+			<File
+				RelativePath="..\..\srtp\include\config.h"
+				>
+			</File>
+			<File
+				RelativePath=".\config_win32.h"
+				>
+			</File>
+			<File
+				RelativePath="..\..\srtp\include\rtp.h"
+				>
+			</File>
+			<File
+				RelativePath="..\..\srtp\include\srtp.h"
+				>
+			</File>
+			<File
+				RelativePath="..\..\srtp\include\ut_sim.h"
+				>
+			</File>
+		</Filter>
+		<Filter
+			Name="crypto"
+			>
+			<Filter
+				Name="ae_xfm"
+				>
+				<File
+					RelativePath="..\..\srtp\crypto\ae_xfm\xfm.c"
+					>
+				</File>
+			</Filter>
+			<Filter
+				Name="cipher"
+				>
+				<File
+					RelativePath="..\..\srtp\crypto\cipher\aes.c"
+					>
+				</File>
+				<File
+					RelativePath="..\..\srtp\crypto\cipher\aes_cbc.c"
+					>
+				</File>
+				<File
+					RelativePath="..\..\srtp\crypto\cipher\aes_icm.c"
+					>
+				</File>
+				<File
+					RelativePath="..\..\srtp\crypto\cipher\cipher.c"
+					>
+				</File>
+				<File
+					RelativePath="..\..\srtp\crypto\cipher\null_cipher.c"
+					>
+				</File>
+			</Filter>
+			<Filter
+				Name="hash"
+				>
+				<File
+					RelativePath="..\..\srtp\crypto\hash\auth.c"
+					>
+				</File>
+				<File
+					RelativePath="..\..\srtp\crypto\hash\hmac.c"
+					>
+				</File>
+				<File
+					RelativePath="..\..\srtp\crypto\hash\null_auth.c"
+					>
+				</File>
+				<File
+					RelativePath="..\..\srtp\crypto\hash\sha1.c"
+					>
+				</File>
+			</Filter>
+			<Filter
+				Name="kernel"
+				>
+				<File
+					RelativePath="..\..\srtp\crypto\kernel\alloc.c"
+					>
+				</File>
+				<File
+					RelativePath="..\..\srtp\crypto\kernel\crypto_kernel.c"
+					>
+				</File>
+				<File
+					RelativePath="..\..\srtp\crypto\kernel\err.c"
+					>
+				</File>
+				<File
+					RelativePath="..\..\srtp\crypto\kernel\key.c"
+					>
+				</File>
+			</Filter>
+			<Filter
+				Name="math"
+				>
+				<File
+					RelativePath="..\..\srtp\crypto\math\datatypes.c"
+					>
+				</File>
+				<File
+					RelativePath="..\..\srtp\crypto\math\gf2_8.c"
+					>
+				</File>
+				<File
+					RelativePath="..\..\srtp\crypto\math\stat.c"
+					>
+				</File>
+			</Filter>
+			<Filter
+				Name="replay"
+				>
+				<File
+					RelativePath="..\..\srtp\crypto\replay\rdb.c"
+					>
+				</File>
+				<File
+					RelativePath="..\..\srtp\crypto\replay\rdbx.c"
+					>
+				</File>
+				<File
+					RelativePath="..\..\srtp\crypto\replay\ut_sim.c"
+					>
+				</File>
+			</Filter>
+			<Filter
+				Name="include"
+				>
+				<File
+					RelativePath="..\..\srtp\crypto\include\aes.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\srtp\crypto\include\aes_cbc.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\srtp\crypto\include\aes_icm.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\srtp\crypto\include\alloc.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\srtp\crypto\include\auth.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\srtp\crypto\include\cipher.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\srtp\crypto\include\crypto.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\srtp\crypto\include\crypto_kernel.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\srtp\crypto\include\crypto_math.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\srtp\crypto\include\crypto_types.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\srtp\crypto\include\cryptoalg.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\srtp\crypto\include\datatypes.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\srtp\crypto\include\err.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\srtp\crypto\include\gf2_8.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\srtp\crypto\include\hmac.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\srtp\crypto\include\integers.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\srtp\crypto\include\kernel_compat.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\srtp\crypto\include\key.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\srtp\crypto\include\null_auth.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\srtp\crypto\include\null_cipher.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\srtp\crypto\include\prng.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\srtp\crypto\include\rand_source.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\srtp\crypto\include\rdb.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\srtp\crypto\include\rdbx.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\srtp\crypto\include\sha1.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\srtp\crypto\include\stat.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\srtp\crypto\include\xfm.h"
+					>
+				</File>
+			</Filter>
+			<Filter
+				Name="rng"
+				>
+				<File
+					RelativePath="..\..\srtp\crypto\rng\ctr_prng.c"
+					>
+				</File>
+				<File
+					RelativePath="..\..\srtp\crypto\rng\prng.c"
+					>
+				</File>
+				<File
+					RelativePath="..\..\srtp\crypto\rng\rand_source.c"
+					>
+				</File>
+			</Filter>
+		</Filter>
+		<Filter
+			Name="tables"
+			>
+			<File
+				RelativePath="..\..\srtp\tables\aes_tables.c"
+				>
+			</File>
+		</Filter>
+	</Files>
+	<Globals>
+	</Globals>
+</VisualStudioProject>
